# Copyright (c) 2021 AccelByte Inc. All Rights Reserved.
# This is licensed software from AccelByte Inc, for limitations
# and restrictions contact your company contract manager.
#
# Code generated. DO NOT EDIT!

# template file: wrapper.j2

# pylint: disable=duplicate-code
# pylint: disable=line-too-long
# pylint: disable=missing-function-docstring
# pylint: disable=missing-function-docstring
# pylint: disable=missing-module-docstring
# pylint: disable=too-many-arguments
# pylint: disable=too-many-branches
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-lines
# pylint: disable=too-many-locals
# pylint: disable=too-many-public-methods
# pylint: disable=too-many-return-statements
# pylint: disable=too-many-statements
# pylint: disable=unused-import

from typing import Any, Dict, List, Optional, Tuple, Union

from accelbyte_py_sdk.core import HeaderStr
from accelbyte_py_sdk.core import get_namespace as get_services_namespace
from accelbyte_py_sdk.core import run_request
from accelbyte_py_sdk.core import run_request_async
from accelbyte_py_sdk.core import same_doc_as

from ..models import ModelCountryBlacklistRequest
from ..models import ModelCountryBlacklistResponse
from ..models import ModelCountryResponse
from ..models import RestErrorResponse

from ..operations.country import AdminAddCountryBlacklistV3
from ..operations.country import AdminGetCountryBlacklistV3
from ..operations.country import AdminGetCountryListV3
from ..operations.country import PublicGetCountryListV3


@same_doc_as(AdminAddCountryBlacklistV3)
def admin_add_country_blacklist_v3(
    body: ModelCountryBlacklistRequest,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Update Country Blacklist (AdminAddCountryBlacklistV3)

    Admin update country blacklist:

    Required Permission: ADMIN:NAMESPACE:{namespace}:MISC [UPDATE]

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:MISC [UPDATE]

    Properties:
        url: /iam/v3/admin/namespaces/{namespace}/countries/blacklist

        method: POST

        tags: ["Country"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        body: (body) REQUIRED ModelCountryBlacklistRequest in body

        namespace: (namespace) REQUIRED str in path

    Responses:
        204: No Content - (No Content)

        400: Bad Request - RestErrorResponse (20002: validation error)

        401: Unauthorized - RestErrorResponse (20001: unauthorized access)

        403: Forbidden - RestErrorResponse (20013: insufficient permissions)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = AdminAddCountryBlacklistV3.create(
        body=body,
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(AdminAddCountryBlacklistV3)
async def admin_add_country_blacklist_v3_async(
    body: ModelCountryBlacklistRequest,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Update Country Blacklist (AdminAddCountryBlacklistV3)

    Admin update country blacklist:

    Required Permission: ADMIN:NAMESPACE:{namespace}:MISC [UPDATE]

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:MISC [UPDATE]

    Properties:
        url: /iam/v3/admin/namespaces/{namespace}/countries/blacklist

        method: POST

        tags: ["Country"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        body: (body) REQUIRED ModelCountryBlacklistRequest in body

        namespace: (namespace) REQUIRED str in path

    Responses:
        204: No Content - (No Content)

        400: Bad Request - RestErrorResponse (20002: validation error)

        401: Unauthorized - RestErrorResponse (20001: unauthorized access)

        403: Forbidden - RestErrorResponse (20013: insufficient permissions)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = AdminAddCountryBlacklistV3.create(
        body=body,
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )


@same_doc_as(AdminGetCountryBlacklistV3)
def admin_get_country_blacklist_v3(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get Country Blacklist (AdminGetCountryBlacklistV3)

    Admin get country blacklist:

    Required Permission: ADMIN:NAMESPACE:{namespace}:MISC [READ]

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:MISC [READ]

    Properties:
        url: /iam/v3/admin/namespaces/{namespace}/countries/blacklist

        method: GET

        tags: ["Country"]

        consumes: []

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - ModelCountryBlacklistResponse (OK)

        401: Unauthorized - RestErrorResponse (20001: unauthorized access)

        403: Forbidden - RestErrorResponse (20013: insufficient permissions)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = AdminGetCountryBlacklistV3.create(
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(AdminGetCountryBlacklistV3)
async def admin_get_country_blacklist_v3_async(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get Country Blacklist (AdminGetCountryBlacklistV3)

    Admin get country blacklist:

    Required Permission: ADMIN:NAMESPACE:{namespace}:MISC [READ]

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:MISC [READ]

    Properties:
        url: /iam/v3/admin/namespaces/{namespace}/countries/blacklist

        method: GET

        tags: ["Country"]

        consumes: []

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - ModelCountryBlacklistResponse (OK)

        401: Unauthorized - RestErrorResponse (20001: unauthorized access)

        403: Forbidden - RestErrorResponse (20013: insufficient permissions)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = AdminGetCountryBlacklistV3.create(
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )


@same_doc_as(AdminGetCountryListV3)
def admin_get_country_list_v3(
    filter_blacklist: Optional[bool] = None,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get Country List (AdminGetCountryListV3)

    Admin get country list

    Properties:
        url: /iam/v3/admin/namespaces/{namespace}/countries

        method: GET

        tags: ["Country"]

        consumes: []

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

        filter_blacklist: (filterBlacklist) OPTIONAL bool in query

    Responses:
        200: OK - List[ModelCountryResponse] (No Content)

        401: Unauthorized - RestErrorResponse (20001: unauthorized access)

        403: Forbidden - RestErrorResponse (20013: insufficient permissions)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = AdminGetCountryListV3.create(
        filter_blacklist=filter_blacklist,
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(AdminGetCountryListV3)
async def admin_get_country_list_v3_async(
    filter_blacklist: Optional[bool] = None,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get Country List (AdminGetCountryListV3)

    Admin get country list

    Properties:
        url: /iam/v3/admin/namespaces/{namespace}/countries

        method: GET

        tags: ["Country"]

        consumes: []

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

        filter_blacklist: (filterBlacklist) OPTIONAL bool in query

    Responses:
        200: OK - List[ModelCountryResponse] (No Content)

        401: Unauthorized - RestErrorResponse (20001: unauthorized access)

        403: Forbidden - RestErrorResponse (20013: insufficient permissions)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = AdminGetCountryListV3.create(
        filter_blacklist=filter_blacklist,
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )


@same_doc_as(PublicGetCountryListV3)
def public_get_country_list_v3(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get Country List (PublicGetCountryListV3)

    Public get country list, will filter out countries in black list

    Properties:
        url: /iam/v3/public/namespaces/{namespace}/countries

        method: GET

        tags: ["Country"]

        consumes: []

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - List[ModelCountryResponse] (OK)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = PublicGetCountryListV3.create(
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(PublicGetCountryListV3)
async def public_get_country_list_v3_async(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get Country List (PublicGetCountryListV3)

    Public get country list, will filter out countries in black list

    Properties:
        url: /iam/v3/public/namespaces/{namespace}/countries

        method: GET

        tags: ["Country"]

        consumes: []

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - List[ModelCountryResponse] (OK)

        500: Internal Server Error - RestErrorResponse (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = PublicGetCountryListV3.create(
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )
